/<template>
  <div>
    <!-- <background /> -->
    <div class="title">
      <img src="../assets/logo.png" alt="" />
      <span>surong_dan</span>
    </div>
    <div class="register-box">
      <el-form
        :model="loginForm"
        ref="loginForm"
        status-icon
        :rules="loginRules"
        label-width="80px"
        label-position="left"
      >
        <el-form-item prop="username" label="用户名">
          <div style="display: flex">
            <el-input
              v-model="loginForm.username"
              placeholder="请输入用户名"
              @keyup.enter.native="handleLogin"
              auto-complete="off"
            >
              <i
                slot="prefix"
                class="el-input__icon el-icon-s-custom"
                style="font-size: 20px"
              ></i>
            </el-input>
          </div>
        </el-form-item>
        <el-form-item prop="password" label="密码">
          <el-input
            placeholder="请输入密码"
            @keyup.enter.native="handleLogin"
            :type="passwordType"
            v-model="loginForm.password"
            auto-complete="off"
          >
            <i
              class="el-input__icon el-icon-view"
              :style="fontstyle"
              slot="suffix"
              style="font-size: 20px"
              @click="showPassword"
            >
            </i>
            <i
              slot="prefix"
              style="font-size: 20px"
              class="el-input__icon el-icon-lock"
            >
            </i>
          </el-input>
        </el-form-item>
        <el-form-item prop="verifycode" label="验证码">
          <!-- 注意：prop与input绑定的值一定要一致，否则验证规则中的value会报undefined，因为value即为绑定的input输入值 -->
          <el-input
            v-model="loginForm.verifycode"
            placeholder="请输入验证码"
            class="identifyinput"
          >
            <i
              slot="prefix"
              class="el-input__icon el-icon-s-check"
              style="font-size: 22px"
            >
            </i>
          </el-input>
        </el-form-item>
        <el-form-item>
          <div class="identifybox">
            <div @click="refreshCode">
              <s-identify :identifyCode="identifyCode"></s-identify>
            </div>
            <el-button @click="refreshCode" type="text" class="textbtn"
              >看不清，换一张</el-button
            >
          </div>
        </el-form-item>
        <el-form-item label-width="0px" class="submitbutton">
          <el-button
            type="primary"
            @click.native.prevent="handleLogin"
            class="login-submit"
            >登录</el-button
          >
        </el-form-item>
        <div class="tags">
          <router-link to="register"><el-tag>立即注册</el-tag> </router-link>
          <router-link to="forgetpwd"><el-tag>忘记密码？</el-tag> </router-link>
        </div>
      </el-form>
    </div>
  </div>
</template>
<script>
import SIdentify from "../components/identify.vue";
import { mapState } from "vuex";
import { Message } from "element-ui";
import background from "@/components/background";
export default {
  name: "CertificateLogin",
  data() {
    // 用户名自定义验证规则
    const validateUsername = (rule, value, callback) => {
      if (!value) {
        callback(new Error("请输入正确的用户名"));
      } else {
        console.log("user", value);
        callback();
      }
    };
    // 验证码自定义验证规则
    const validateVerifycode = (rule, value, callback) => {
      let newVal = value.toLowerCase();
      let identifyStr = this.identifyCode.toLowerCase();
      if (newVal === "") {
        callback(new Error("请输入验证码"));
      } else if (newVal !== identifyStr) {
        console.log("validateVerifycode:", value);
        callback(new Error("验证码不正确!"));
      } else {
        callback();
      }
    };
    return {
      // show: false,
      activeIndex: "1",
      dialogVisible: false,
      fontstyle: {
        color: "gray",
      },
      loginForm: {
        username: "",
        password: "",
        verifycode: "",
      },
      checked: false,
      identifyCodes: "1234567890ABCDEFGHIGKLMNoPQRSTUVWXYZ",
      identifyCode: "",
      loginRules: {
        // 绑定在form表单中的验证规则
        username: [
          { required: true, trigger: "blur", validator: validateUsername },
        ],
        password: [
          { required: true, message: "请输入密码", trigger: "blur" },
          { min: 6, message: "密码长度最少为6位", trigger: "blur" },
        ],
        verifycode: [
          { required: true, trigger: "blur", validator: validateVerifycode },
        ],
      },
      passwordType: "password",
    };
  },
  components: {
    SIdentify,
    background,
  },
  created() {},
  mounted() {
    // 验证码初始化
    this.identifyCode = "";
    this.makeCode(this.identifyCodes, 4);
  },
  filters: {
    checkChange(formName) {
      if (this.checked === true) {
        this.loginForm.username = "admin";
        this.loginForm.password = "111111";
        this.loginForm.verifycode = "";
      } else {
        this.$nextTick(() => {
          this.$refs[formName].resetFields();
        });
      }
    },
  },
  computed: {
    ...mapState("login", ["LoginData"]),
  },
  props: [],
  methods: {
    getPhoto() {},
    // 通过改变input的type使密码可见
    showPassword() {
      this.fontstyle.color === "gray"
        ? (this.fontstyle.color = "blue")
        : (this.fontstyle.color = "gray"); // 改变密码可见按钮颜色
      this.passwordType === ""
        ? (this.passwordType = "password")
        : (this.passwordType = "");
    },
    // 点击登入按钮
    handleLogin() {
      console.log("enter handleLogin!!!!");
      this.$refs.loginForm.validate(async (valid) => {
        if (valid) {
          console.log("valid success!!!!");
          let userdata = {};
          userdata["user_info"] = this.loginForm.username;
          userdata["user_pwd"] = this.loginForm.password;
          await this.$store.dispatch("login/SubmitLogin", userdata);
          console.log("LoginData:", this.LoginData);
          Message({
            message: "欢迎登陆，" + this.LoginData.user_name,
            type: "success",
          });
          this.$router.push("/home");
        } else {
          Message({
            message: "登录失败",
            type: "error",
          });
        }
      });
    },
    // 生成随机数
    randomNum(min, max) {
      return Math.floor(Math.random() * (max - min) + min);
    },
    // 切换验证码
    refreshCode() {
      this.identifyCode = "";
      this.makeCode(this.identifyCodes, 4);
    },
    // 生成四位随机验证码
    makeCode(o, l) {
      for (let i = 0; i < l; i++) {
        this.identifyCode +=
          this.identifyCodes[this.randomNum(0, this.identifyCodes.length)];
      }
      console.log(this.identifyCode);
    },
    applyFor() {
      this.dialogVisible = true;
    },
    handleClose(done) {
      done();
    },
    // handleLogin () {
    //   alert('登陆成功')
    //   this.dialogVisible = false
    // },
    handleSelect(key, keyPath) {
      console.log(key, keyPath);
    },
  },
};
</script>

<style lang="scss" scoped>
.title {
  user-select: none;
  display: flex;
  justify-content: center;
  align-items: center;
  min-height: 80px;
  height: 20vh;
  img {
    height: 70px;
  }
  span {
    font-size: 3rem;
    margin-left: 10px;
  }
}
.register-box {
  width: 420px;
  height: 420px;
  box-sizing: border-box;
  border-radius: 10px;
  box-shadow: 0 0 20px #ccc;
  background: rgba($color: #fff, $alpha: 0.2);
  margin: 0 auto;
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  position: relative;
  el-form {
    position: relative;
    z-index: 1;
    width: 100%;
  }
  .identifybox {
    display: flex;
    justify-content: space-between;
    align-items: center;
    margin-top: 7px;
  }
  .iconstyle {
    color: #409eff;
  }
  .login-submit {
    width: 100px;
  }
  .submitbutton {
    display: flex;
    justify-content: center;
  }
  el-input {
    display: inline-block;
  }
  .logo {
    height: 150px;
    width: 100%;
  }
  .tags {
    display: flex;
    justify-content: space-between;
  }
}
</style>
